<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Shop</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">
    <link rel="stylesheet" href="/static/css/styles.css">
    <link rel="stylesheet" href="https://code.jquery.com/ui/1.10.2/themes/smoothness/jquery-ui.css" />
    <script src="/static/js/service.js"></script>
    <script src="//code.jquery.com/jquery-1.10.2.js"></script>
    <script src="//code.jquery.com/ui/1.11.4/jquery-ui.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>

</head>
<body>
    <nav class="navbar" style="height: 60px; padding: 0px; background-color:#66a3ff;">
        <div class="collapse navbar-collapse justify-content-between" style="text-align: center; display:block;" id="navbar">
            <a class="navbar-brand shop-header" href="" id="shopName"></a>
        </div>
    </nav>

    <div class="wrapper" id="background" style="background-image: url('../static/images/mops.jpg');
            background-position: center; background-repeat: no-repeat; background-size: 100%;">
        <nav id="sidebar">
            <div class="sidebar-header" style="padding: 20px 0px 0px 20px;">
                <a href="" style="pointer-events: none; cursor: default;">Categories</a>
            </div>

            <ul class="list-unstyled components" id="categories"></ul>

            <div id="filters" style="display: none">
                <div class="sidebar-header" style="padding: 20px 0px 0px 20px;">
                    <a href="" style="pointer-events: none; cursor: default;">Filters</a>
                </div>
                <div class="shop-filter">
                    <label style="width: 100%; text-align: center;">Price:</label>
                    <label>From </label>
                    <input type="text" id="minPrice" value=""/>
                    <label> to </label>
                    <input type="text" id="maxPrice" value=""/>
                    <div class="slider-container">
                        <div class="" id="sliderPrice"></div>
                    </div>

                    <label style="width: 100%; text-align: center;">Warranty period:</label>
                    <label>From </label>
                    <input type="text" id="minWarranty" value=""/>
                    <label> to </label>
                    <input type="text" id="maxWarranty" value=""/>
                    <div class="slider-container">
                        <div class="" id="sliderWarranty"></div>
                    </div>

                    <label style="width: 100%; text-align: center;">Installment plan:</label>
                    <div style="display: flex; align-items: center; justify-content: center;>">
                        <label>Show installment </label>
                        <input type="checkbox" id="installment" checked>
                    </div>

                    <div style="display: flex; align-items: center; justify-content: center; margin-top: 10px;">
                        <button class="btn btn-primary" type="submit" id="clearFilters" style="text-align: center; width: 100px; margin-right: 10px;">Clear filters</button>
                        <button class="btn btn-primary" type="submit" id="applyFilters" style="text-align: center; width: 100px;">Show results</button>
                    </div>
                </div>
            </div>

            <div class="shop-text" style="text-align: center; margin-top: 20px;">
                <div>
                    <label>Phone: </label>
                <label id="shopPhone"></label>
                </div>
                <div>
                    <label>Address: </label>
                    <label id="shopAddress"></label>
                </div>
                <a href="\admin" style="margin-top: 20px; width: 100px;">Go to admin's page</a>
            </div>
        </nav>

        <div style="width: 100%; height: 100%;">
            <div class="shop-path">
                <div id="path" class="shop-path-text" style="float: left; margin-left: 20px;">Home</div>
                <div style="float: right; display: none" id="categoryButtons">
                    <button class="btn btn-primary" type="submit" style="margin-right: 10px; width: 120px;" id="lowPriced">5 low priced</button>
                    <button class="btn btn-primary" type="submit" style="margin-right: 10px; width: 120px;" id="highPriced">5 high priced</button>
                </div>
            </div>
            <div class="shop-path">
                <div class="shop-path-text" id="categoryInfo"></div>
            </div>
            <div id="field" style="padding: 20px;"></div>
        </div>
    </div>

    <div class="modal" id="buyModal">
        <div class="modal-dialog" style="max-width: 850px;">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title">Buy product</h4>
                    <button type="button" class="close" data-dismiss="modal" id="buyClose">&times;</button>
                </div>

                <div class="modal-body">
                    <img src="" id="buyImage" alt="Product image" style="min-width: 400px; min-height: 300px; max-width: 400px; max-height: 300px; float: left;">
                    <textarea id="buyTextarea" style="width: 400px; height: 300px; float: left; padding: 15px;" readonly></textarea>
                </div>

                <div class="modal-footer">
                    <div class="container">
                        <label><strong>Your name</strong></label>
                        <input class="login-input" type="text" placeholder="Nice mops" id="buyName" required>
                        <label><strong>Your phone</strong></label>
                        <input class="login-input" type="text" placeholder="8(802)9848233" id="buyPhone" required>
                        <button class="login-button" type="submit" id="makeOrder">Make order</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

<script>
    var rowLen = 5
    var curCat = ""

    $('#filters').hide()

    var categoriesNames = JSON.parse('{{categories | safe}}')
    var shopInfo = JSON.parse('{{shop_info | safe}}')
    $('#shopName').text(shopInfo["name"])
    $('#shopPhone').text(shopInfo["phone"])
    $('#shopAddress').text(shopInfo["address"])

    if (categoriesNames !== 0) {
        addCategories(categoriesNames)
    }

    $('#categories').on('click', 'a', function() {
        if (this.parentNode.getElementsByClassName("list-unstyled")[0].childNodes.length === 0) {
            $('#background').css({"background": "linear-gradient(rgba(204, 224, 255, 0.7), rgba(204, 224, 255, 0.7)), url('../static/images/mops.jpg')",
                                  "background-position": "center", "background-repeat": "no-repeat", "background-size": "100%"})
            $('#categoryButtons').show()
            curCat = this.text
            curCat = curCat.substring(0, curCat.indexOf(" ") - 1)
            console.log("Open category: " + curCat)

            var xhr = sendRequest("GET", "/products?category=" + curCat, function(){
                var json = JSON.parse(xhr.responseText)
                createItemsTable(json["products"], "product")
            })

            var xhr1 = sendRequest("GET", "category_path?category=" + curCat, function(){
                var json = JSON.parse(xhr1.responseText)
                var p = document.getElementById('path')
                p.innerHTML = "Path: " + json["path"]
            })

            var xhr2 = sendRequest("GET", "filter_values?category=" + curCat, function(){
                var json = JSON.parse(xhr2.responseText)
                $("#sliderPrice").slider({
                    min: json["values"]["min_price"],
                    max: json["values"]["max_price"],
                    values: [json["values"]["min_price"], json["values"]["max_price"]],
                    range: true,
                    stop: function(event, ui) {
                        $("input#minPrice").val($("#sliderPrice").slider("values",0))
                        $("input#maxPrice").val($("#sliderPrice").slider("values",1))
                    },
                    slide: function(event, ui){
                        $("input#minPrice").val($("#sliderPrice").slider("values",0))
                        $("input#maxPrice").val($("#sliderPrice").slider("values",1))
                    }
                })
                $("input#minPrice").val(json["values"]["min_price"])
                $("input#maxPrice").val(json["values"]["max_price"])
                $("#sliderWarranty").slider({
                    min: json["values"]["min_warranty"],
                    max: json["values"]["max_warranty"],
                    values: [json["values"]["min_warranty"], json["values"]["max_warranty"]],
                    range: true,
                    stop: function(event, ui) {
                        $("input#minWarranty").val($("#sliderWarranty").slider("values",0))
                        $("input#maxWarranty").val($("#sliderWarranty").slider("values",1))
                    },
                    slide: function(event, ui){
                        $("input#minWarranty").val($("#sliderWarranty").slider("values",0))
                        $("input#maxWarranty").val($("#sliderWarranty").slider("values",1))
                    }
                })
                $("input#minWarranty").val(json["values"]["min_warranty"])
                $("input#maxWarranty").val(json["values"]["max_warranty"])
            })
            $('#filters').show()

            var xhr3 = sendRequest("GET", "category_info?category=" + curCat, function(){
                var json = JSON.parse(xhr3.responseText)
                var p = document.getElementById('categoryInfo')
                p.innerHTML = "&nbsp;&nbsp;&nbsp;Average price: " + json["info"]["avg_price"] +
                              ",&nbsp;&nbsp;&nbsp;minimum price: " + json["info"]["min_price"] +
                              ",&nbsp;&nbsp;&nbsp;maximum price: " + json["info"]["max_price"] +
                              ",&nbsp;&nbsp;&nbsp;products count: " + json["info"]["count"]
            })
            $('#categoryInfo').show()
        }
    })

    $('#applyFilters').on('click', function() {
        var xhr = sendRequest("GET", "filtered_products?category=" + curCat +
                                     "&min_price=" + $("input#minPrice").val() +
                                     "&max_price=" + $("input#maxPrice").val() +
                                     "&min_warranty=" + $("input#minWarranty").val() +
                                     "&max_warranty=" + $("input#maxWarranty").val() +
                                     "&installment=" + $("input#installment").is(":checked"),
                                     function(){
            var json = JSON.parse(xhr.responseText)
            console.log(json)
            createItemsTable(json["products"], "product")
        })
    })

    $('#clearFilters').on('click', function() {
        $('installment').prop('checked', true);

        var xhr = sendRequest("GET", "/products?category=" + curCat, function(){
                var json = JSON.parse(xhr.responseText)
                createItemsTable(json["products"], "product")
        })

        var xhr2 = sendRequest("GET", "filter_values?category=" + curCat, function(){
            var json = JSON.parse(xhr2.responseText)
            $("#sliderPrice").slider({
                min: json["values"]["min_price"],
                max: json["values"]["max_price"],
                values: [json["values"]["min_price"], json["values"]["max_price"]],
                range: true,
                stop: function(event, ui) {
                    $("input#minPrice").val($("#sliderPrice").slider("values",0))
                    $("input#maxPrice").val($("#sliderPrice").slider("values",1))
                },
                slide: function(event, ui){
                    $("input#minPrice").val($("#sliderPrice").slider("values",0))
                    $("input#maxPrice").val($("#sliderPrice").slider("values",1))
                }
            })
            $("input#minPrice").val(json["values"]["min_price"])
            $("input#maxPrice").val(json["values"]["max_price"])
            $("#sliderWarranty").slider({
                min: json["values"]["min_warranty"],
                max: json["values"]["max_warranty"],
                values: [json["values"]["min_warranty"], json["values"]["max_warranty"]],
                range: true,
                stop: function(event, ui) {
                    $("input#minWarranty").val($("#sliderWarranty").slider("values",0))
                    $("input#maxWarranty").val($("#sliderWarranty").slider("values",1))
                },
                slide: function(event, ui){
                    $("input#minWarranty").val($("#sliderWarranty").slider("values",0))
                    $("input#maxWarranty").val($("#sliderWarranty").slider("values",1))
                }
            })
            $("input#minWarranty").val(json["values"]["min_warranty"])
            $("input#maxWarranty").val(json["values"]["max_warranty"])
        })
        $('#filters').show()
    })

    $('#lowPriced').on('click', function() {
        var xhr = sendRequest("GET", "/low_priced_products?category=" + curCat + "&n=" + 5, function(){
            var json = JSON.parse(xhr.responseText)
            createItemsTable(json["products"], "product")
        })
    })

    $('#highPriced').on('click', function() {
        var xhr = sendRequest("GET", "/high_priced_products?category=" + curCat + "&n=" + 5, function(){
            var json = JSON.parse(xhr.responseText)
            createItemsTable(json["products"], "product")
        })
    })

    $('#buyClose').on('click', function() {
        $('#buyModal').hide()
    })

    $('#makeOrder').on('click', function() {
        alert("Your successfully made order. Please, wait for operators call");
        $('#buyModal').hide()
    })

    $('#field').on('click', '.col', function() {
        var id = $(this).attr("id")
        id = id.slice(1)
        $('#buyImage').attr("src", $(this).children().eq(0).attr("src"))

        var xhr = sendRequest("GET", "/product_info?id=" + id, function(){
            var json = JSON.parse(xhr.responseText)
            json = json["products"]
            text = "Name: " + json["name"] + "\nBrand: " + json["brand"] + "\nPrice: " + json["price"] +
                   "\nWarranty_period: " + json["warranty_period"] + "\nDescription: " + json["description"]
            $('#buyTextarea').text(text)
            $('#buyModal').show()
        })
    })
</script>
</body>
</html>